/** ListTimer.java times ArrayList and LinkedList operations.
 *  Output:  Time required to do these operations.
 */

import ann.util.Timer;
import java.util.*;       // LinkedList, ArrayList

class ListTimer extends Object
{
 public static void main(String [] args)
 {
   final int START = 10000,
             STEP = 10000,
             STOP = 10000000;
   Timer timer = new Timer();
   int i, j;
   Object obj = new Object();
   ArrayList anArrayList = new ArrayList();
   LinkedList aLinkedList = new LinkedList();

   for (i = 1; i <= START; i++)           // build initial lists
   {
     anArrayList.add(obj);
     aLinkedList.add(obj);
   }
                                          // print column headings
   System.out.println("Size    a.add() l.add() a.get(m)        "
                      + "l.get(m)        a.add(0)        l.add(0)");

   for (i = START; i <= STOP; i += STEP)  // main loop
   {
     timer.start();
     anArrayList.add(obj);                // append obj to an ArrayList
     timer.stop();

     System.out.print(i + "\t" + timer);  // display i and the time

     timer.reset();
     timer.start();
     aLinkedList.add(obj);                // append obj to a LinkedList
     timer.stop();

     System.out.print("\t" + timer);      // display time

     int middleIndex = i / 2;
     timer.reset();
     timer.start();
     obj = anArrayList.get(middleIndex);  // access middle value in AL
     timer.stop();
     System.out.print("\t" + timer);

     timer.reset();
     timer.start();
     obj = aLinkedList.get(middleIndex);  // access middle value in LL
     timer.stop();
     System.out.print("\t\t" + timer);

     timer.reset();
     timer.start();
     anArrayList.add(0, obj);             // prepend value to an AL
     timer.stop();
     System.out.print("\t\t" + timer);

     timer.reset();
     timer.start();
     aLinkedList.add(0, obj);
     timer.stop();
     System.out.println("\t\t" + timer);  // prepend value to a LL
       
     for (j = 1; j <= STEP; j++)          // increase size of lists
     {
       anArrayList.add(obj);
       aLinkedList.add(obj);
     }
   }
 }
}

